
#define NUM_CURSOR_FRAMES 15

void M_Menu_Main_f (void);
void M_Menu_Game_f (void);
void M_Menu_LoadGame_f (void);
void M_Menu_SaveGame_f (void);
void M_Menu_PlayerConfig_f (void);
void M_Menu_DownloadOptions_f (void);
void M_Menu_Credits_f (void);
void M_Menu_Multiplayer_f (void);
void M_Menu_JoinServer_f (void);
void M_Menu_AddressBook_f (void);
void M_Menu_StartServer_f (void);
void M_Menu_DMOptions_f (void);
void M_Menu_Video_f (void);
void M_Menu_Options_f (void);
void M_Menu_Keys_f (void);
void M_Menu_Quit_f (void);
void M_Menu_Credits (void);

extern char *menu_in_sound;
extern char *menu_move_sound;
extern char *menu_out_sound;

extern qboolean m_entersound;

const char *Default_MenuKey (menuframework_s *m, int key);
void M_Banner (char *name);
float ClampCvar (float min, float max, float value);

void M_DrawTextBox (int x, int y, int width, int lines);
void M_DrawCursor (int x, int y, int f);
void M_Print (int cx, int cy, char *str);
void M_PrintWhite (int cx, int cy, char *str);
void M_DrawPic (int x, int y, char *pic);
void M_DrawPointer (int x, int y);

void M_PopMenu (void);
void M_ForceMenuOff (void);
void M_PushMenu (void (*draw) (void), const char *(*key) (int k));

// for making this available as a menu option
void CL_WriteConfiguration (void);
