/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "versions.h"
#include "qcommon.h"
#include "client.h"
#include "server.h"

#include <windows.h>
#include <stdio.h>
#include <process.h>
#include <windows.h>

#include "conproc.h"
#include "winquake.h"
#include "q_shared.h"

#include <ctype.h>
#include <io.h>
#include "client.h"
#include "qmenu.h"

#include "winsock.h"
#include "wsipx.h"
#include "qcommon.h"

#include "qcommon.h"
#include "winquake.h"
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <direct.h>
#include <io.h>
#include <conio.h>

#include <float.h>

#include <string.h>
#include <ctype.h>

#include "client.h"
#include "qmenu.h"

#include "client.h"
#include "snd_loc.h"

#include "server.h"

#include "qcommon.h"
#include "winquake.h"
#include "resource.h"
#include <errno.h>
#include <float.h>
#include <fcntl.h>
#include <stdio.h>
#include <direct.h>
#include <io.h>
#include <conio.h>
#include "conproc.h"

#include <assert.h>
#include <float.h>

#include "client.h"
#include "winquake.h"

#include "client.h"
#include "qmenu.h"

#include <stdlib.h>
#include <stddef.h>
#include <stdint.h>
#include "client.h"

// let's have this one too...
void *Scratch_Alloc (void);
void *Scratch_AllocSize (int size);
void Scratch_FreeToLowMark (int mark);
int Scratch_LowMark (void);

#define MAX_LIST_ITEMS		16384

typedef struct itemlist_s
{
	char **items;
	int numitems;
	HANDLE heap;
} itemlist_t;


void FreeItemList (itemlist_t *list);
void BuildItemList (itemlist_t *list, void (*BuildFunc) (itemlist_t *, void *), void *extradata, qboolean sort);
void CopyItemListItem (itemlist_t *list, char *src);
void FS_EnumContent (void (*Callback) (char *));
void FS_RecursiveDirectoryTraverse (char *dirname, void (*Callback) (char *));
void Cmd_SetupSaveGamesAutoComplete (void);
void FS_EnumSaves (itemlist_t *ac);
void Cmd_CopyStringToAutoComplete (itemlist_t *ac, char *name);

